#pragma once

namespace RegExp {

class NullType {};

template <int n>
struct Int2Type
{
    enum { value = n };
};

template <class T>
struct Type2Type
{
    typedef T result;
};

template <class T, class U>
struct TypeList
{
    typedef T Head;
    typedef U Tail;
};

#define TL_1(T1) TypeList<T1, NullType >
#define TL_2(T1, T2) TypeList<T1, TL_1(T2) >
#define TL_3(T1, T2, T3) TypeList<T1, TL_2(T2, T3) >
#define TL_4(T1, T2, T3, T4) TypeList<T1, TL_3(T2, T3, T4) >
#define TL_5(T1, T2, T3, T4, T5) TypeList<T1, TL_4(T2, T3, T4, T5) >
#define TL_6(T1, T2, T3, T4, T5, T6) TypeList<T1, TL_5(T2, T3, T4, T5, T6) >
#define TL_7(T1, T2, T3, T4, T5, T6, T7) TypeList<T1, TL_6(T2, T3, T4, T5, T6, T7) >
#define TL_8(T1, T2, T3, T4, T5, T6, T7, T8) TypeList<T1, TL_7(T2, T3, T4, T5, T6, T7, T8) >
#define TL_9(T1, T2, T3, T4, T5, T6, T7, T8, T9) TypeList<T1, TL_8(T2, T3, T4, T5, T6, T7, T8, T9) >
#define TL_10(T1, T2, T3, T4, T5, T6, T7, T8, T9, T10) TypeList<T1, TL_9(T2, T3, T4, T5, T6, T7, T8, T9, T10) >

#define C_1(C1) E<TL_1(C<'C1'>) >
#define C_2(C1, C2) E<TL_2(C<'C1'>,C<'C2'>) >
#define C_3(C1, C2, C3) E<TL_3(C<'C1'>,C<'C2'>,C<'C3'>) >
#define C_4(C1, C2, C3, C4) E<TL_4(C<'C1'>,C<'C2'>,C<'C3'>,C<'C4'>) >
#define C_5(C1, C2, C3, C4, C5) E<TL_5(C<'C1'>,C<'C2'>,C<'C3'>,C<'C4'>,C<'C5'>) >
#define C_6(C1, C2, C3, C4, C5, C6) E<TL_6(C<'C1'>,C<'C2'>,C<'C3'>,C<'C4'>,C<'C5'>,C<'C6'>) >
#define C_7(C1, C2, C3, C4, C5, C6, C7) E<TL_7(C<'C1'>,C<'C2'>,C<'C3'>,C<'C4'>,C<'C5'>,C<'C6'>,C<'C7'>) >
#define C_8(C1, C2, C3, C4, C5, C6, C7, C8) E<TL_8(C<'C1'>,C<'C2'>,C<'C3'>,C<'C4'>,C<'C5'>,C<'C6'>,C<'C7'>,C<'C8'>) >
#define C_9(C1, C2, C3, C4, C5, C6, C7, C8, C9) E<TL_9(C<'C1'>,C<'C2'>,C<'C3'>,C<'C4'>,C<'C5'>,C<'C6'>,C<'C7'>,C<'C8'>,C<'C9'>) >
#define C_10(C1, C2, C3, C4, C5, C6, C7, C8, C9, C10) E<TL_10(C<'C1'>,C<'C2'>,C<'C3'>,C<'C4'>,C<'C5'>,C<'C6'>,C<'C7'>,C<'C8'>,C<'C9'>,C<'C10'>) >

#define E_1(C1) E< C1 >
#define E_2(C1, C2) E< TL_2(C1, C2) >
#define E_3(C1, C2, C3) E< TL_3(C1, C2, C3) >
#define E_4(C1, C2, C3, C4) E< TL_4(C1, C2, C3, C4) >
#define E_5(C1, C2, C3, C4, C5) E< TL_5(C1, C2, C3, C4, C5) >
#define E_6(C1, C2, C3, C4, C5, C6) E< TL_6(C1, C2, C3, C4, C5, C6) >
#define E_7(C1, C2, C3, C4, C5, C6, C7) E< TL_7(C1, C2, C3, C4, C5, C6, C7) >
#define E_8(C1, C2, C3, C4, C5, C6, C7, C8) E< TL_8(C1, C2, C3, C4, C5, C6, C7, C8) >
#define E_9(C1, C2, C3, C4, C5, C6, C7, C8, C9) E< TL_9(C1, C2, C3, C4, C5, C6, C7, C8, C9) >
#define E_10(C1, C2, C3, C4, C5, C6, C7, C8, C9, C10) E< TL_10(C1, C2, C3, C4, C5, C6, C7, C8, C9, C10) >

#define D_1(C1) D< C1 >
#define D_2(C1, C2) D< TL_2(C1, C2) >
#define D_3(C1, C2, C3) D< TL_3(C1, C2, C3) >
#define D_4(C1, C2, C3, C4) D< TL_4(C1, C2, C3, C4) >
#define D_5(C1, C2, C3, C4, C5) D< TL_5(C1, C2, C3, C4, C5) >
#define D_6(C1, C2, C3, C4, C5, C6) D< TL_6(C1, C2, C3, C4, C5, C6) >
#define D_7(C1, C2, C3, C4, C5, C6, C7) D< TL_7(C1, C2, C3, C4, C5, C6, C7) >
#define D_8(C1, C2, C3, C4, C5, C6, C7, C8) D< TL_8(C1, C2, C3, C4, C5, C6, C7, C8) >
#define D_9(C1, C2, C3, C4, C5, C6, C7, C8, C9) D< TL_9(C1, C2, C3, C4, C5, C6, C7, C8, C9) >
#define D_10(C1, C2, C3, C4, C5, C6, C7, C8, C9, C10) D< TL_10(C1, C2, C3, C4, C5, C6, C7, C8, C9, C10) >

#define S_1(C1) S< C1 >
#define S_2(C1, C2) S< TL_2(C1, C2) >
#define S_3(C1, C2, C3) S< TL_3(C1, C2, C3) >
#define S_4(C1, C2, C3, C4) S< TL_4(C1, C2, C3, C4) >
#define S_5(C1, C2, C3, C4, C5) S< TL_5(C1, C2, C3, C4, C5) >
#define S_6(C1, C2, C3, C4, C5, C6) S< TL_6(C1, C2, C3, C4, C5, C6) >
#define S_7(C1, C2, C3, C4, C5, C6, C7) S< TL_7(C1, C2, C3, C4, C5, C6, C7) >
#define S_8(C1, C2, C3, C4, C5, C6, C7, C8) S< TL_8(C1, C2, C3, C4, C5, C6, C7, C8) >
#define S_9(C1, C2, C3, C4, C5, C6, C7, C8, C9) S< TL_9(C1, C2, C3, C4, C5, C6, C7, C8, C9) >
#define S_10(C1, C2, C3, C4, C5, C6, C7, C8, C9, C10) S< TL_10(C1, C2, C3, C4, C5, C6, C7, C8, C9, C10) >

}
