#pragma once
#include "RegExp.h"

namespace RegExp {

typedef C<'0','9'>                                   Digit;
typedef C<'A','F'>                                   HexUpper;
typedef C<'a','f'>                                   HexLower;
typedef D_2(HexUpper, HexLower)                      Hex;
typedef C<'0','1'>                                   Max1w0;
typedef C<'0','2'>                                   Max2w0;
typedef C<'0','4'>                                   Max4w0;
typedef C<'0','5'>                                   Max5w0;
typedef C<'1','2'>                                   Max2;
typedef C<'0','5'>                                   Max5;

//     
typedef E_2(Max2, Digit)                             Octet29;
typedef E_2(C<3>, Max2w0)                            Octet32;
typedef D_3(Digit, Octet29, Octet32)                 IPMaskShort;
typedef Q<Max1w0, NullType, 0, 1, qtGreed>           IPForm1p1;
typedef Q<Digit,  NullType, 0, 1>                    IPForm1p2;
typedef E_3(IPForm1p1, Digit, IPForm1p2)             IPForm1;
typedef E_3(C<'2'>, Max4w0, Digit)                   IPForm2;
typedef E_3(C<'2'>, C<'5'>, Max5w0)                  IPForm3;
typedef B< D_3(IPForm3, IPForm2, IPForm1) >          IPOctet;
typedef Q< E_2(C<'.'>, IPOctet), NullType, 3, 3 >    IPTail;
typedef E_2(IPOctet, IPTail)                         IPAddress;
typedef D_2(IPAddress, IPMaskShort)                  IPMask;
typedef Q< E_2(C<'/'>, IPMask), NullType, 0, 1 >     IPSuffix;
typedef E_2(IPAddress, IPSuffix)                     IPWithMask;

// Mac-
typedef B< Q<Hex, NullType, 2, 2> >                  MacOctet;
typedef Q< E_2(C<':'>, MacOctet), NullType, 5, 5 >   MacTail;
typedef E_2(MacOctet, MacTail)                       MacAddress;

}
